--- duperemove-0.11~beta4.orig/file_scan.c
+++ duperemove-0.11~beta4/file_scan.c
@@ -660,7 +660,7 @@ static void csum_whole_file_init(GMutex
 	unsigned long long cur_scan_files;
 	*mutex = g_dataset_get_data(location, "mutex");
 
-	cur_scan_files = __sync_add_and_fetch(&_cur_scan_files, 1);
+	cur_scan_files = __atomic_fetch_add(&_cur_scan_files, 1, __ATOMIC_SEQ_CST);
 
 	printf("[%0*llu/%llu] (%05.2f%%) csum: %s\n",
 	       leading_spaces, cur_scan_files, files_to_scan,
--- duperemove-0.11~beta4.orig/run_dedupe.c
+++ duperemove-0.11~beta4/run_dedupe.c
@@ -476,7 +476,7 @@ static int extent_dedupe_worker(struct d
 				uint64_t *fiemap_bytes, uint64_t *kern_bytes)
 {
 	int ret;
-	unsigned long long passno = __sync_add_and_fetch(&curr_dedupe_pass, 1);
+	unsigned long long passno = __atomic_fetch_add(&curr_dedupe_pass, 1, __ATOMIC_SEQ_CST);
 
 	ret = dedupe_extent_list(dext, fiemap_bytes, kern_bytes, passno);
 	if (ret) {
@@ -653,7 +653,7 @@ static int block_dedupe_worker(struct bl
 {
 	int ret;
 	struct results_tree res;
-	unsigned long long passno = __sync_add_and_fetch(&curr_dedupe_pass, 1);
+	unsigned long long passno =  __atomic_fetch_add(&curr_dedupe_pass, 1, __ATOMIC_SEQ_CST);
 
 	init_results_tree(&res);
 
@@ -798,8 +798,8 @@ static int __push_blocks(struct hash_tre
 						goto out;
 					bdl = NULL;
 
-					__sync_add_and_fetch(
-						&total_dedupe_passes, 1);
+					 __atomic_fetch_add(
+						&total_dedupe_passes, 1, __ATOMIC_SEQ_CST);
 					break;
 				}
 			}
